
use census
go

-- for geography
select * from zipcodes z
join Congress c
on z.shapegeog.STIntersects(c.shapegeog)=1
where c.id = 116

-- 1. New query hint for spatial indexed queries
select * from zipcodes z with(SPATIAL_WINDOW_MAX_CELLS=1536)
join Congress c
on z.shapegeog.STIntersects(c.shapegeog)=1
where c.id = 116

-- 2. BUG: This executes but does not use the hint
select * from zipcodes z 
join Congress c
on z.shapegeog.STIntersects(c.shapegeog)=1
where c.id = 116
OPTION (TABLE HINT(z, SPATIAL_WINDOW_MAX_CELLS=1536))

-- same for geometry
select * from zipcodes z
join Congress c
on z.shape.STIntersects(c.shape)=1
where c.id = 116

select * from zipcodes z with(SPATIAL_WINDOW_MAX_CELLS=1536)
join Congress c
on z.shape.STIntersects(c.shape)=1
where c.id = 116