
drop database test
go

create database test
go

use test
go

drop table docs
go

create table docs (
 id int identity primary key,
 doctype varchar(20),
 doc varbinary(max)
)
go 

sp_helpindex 'docs'

CREATE SEARCH PROPERTY LIST DocumentProperties;
GO
ALTER SEARCH PROPERTY LIST DocumentProperties
   ADD 'Title' 
   WITH ( PROPERTY_SET_GUID = 'F29F85E0-4FF9-1068-AB91-08002B27B3D9', PROPERTY_INT_ID = 2, 
      PROPERTY_DESCRIPTION = 'System.Title - Title of the item.' );
ALTER SEARCH PROPERTY LIST DocumentProperties
    ADD 'Author'
   WITH ( PROPERTY_SET_GUID = 'F29F85E0-4FF9-1068-AB91-08002B27B3D9', PROPERTY_INT_ID = 4, 
      PROPERTY_DESCRIPTION = 'System.Author - Author or authors of the item.' );
ALTER SEARCH PROPERTY LIST DocumentProperties 
    ADD 'Tags'
   WITH ( PROPERTY_SET_GUID = 'F29F85E0-4FF9-1068-AB91-08002B27B3D9', PROPERTY_INT_ID = 5, 
      PROPERTY_DESCRIPTION = 'System.Keywords - Keywords (Tags) of the item.' );
GO

CREATE FULLTEXT CATALOG ftCatalog AS DEFAULT;
GO

CREATE FULLTEXT INDEX ON docs(
[Doc] TYPE COLUMN [doctype] LANGUAGE [English]
)
KEY INDEX [PK__docs__3213E83FE21A9E70] ON ([FTCatalog])
WITH (CHANGE_TRACKING = AUTO, STOPLIST = SYSTEM, search property list = DocumentProperties)
go

ALTER FULLTEXT INDEX ON docs
   START FULL POPULATION;
GO

-- until status = 0 (populated, idle)
select objectpropertyex(object_id('docs'),'TableFulltextPopulateStatus')

-- 3. search property list and related metadata
select * from sys.registered_search_properties 
select * from sys.registered_search_property_lists
select * from sys.dm_fts_index_keywords_by_property(
 DB_ID('test'), 
 OBJECT_ID('docs'))

-- 4. search by property
SELECT * FROM docs
  WHERE CONTAINS(PROPERTY(doc,'Title'), 'Sample');
GO

SELECT * FROM docs
  WHERE CONTAINS(PROPERTY(doc,'Author'), 'Bob');
GO

SELECT * FROM docs
  WHERE CONTAINS(doc, 'sample');
GO

declare @x varbinary(max)
SET @x = ( 
 SELECT * FROM OPENROWSET
  (BULK 'c:\temp\docs\Beijing.jpg',
   SINGLE_BLOB)
   as X)

--insert into docs values(NULL,@x)
--insert into docs values('docx',@x)
--insert into docs values('.docx',@x)
insert into docs values('.jpg',@x)

select * from docs

select * from adventureworks2008r2.Production.Document

select * from sys.internal_tables

-- need DAC for this
select * from sys.fulltext_indexeddocid_309576141

select document_type, path from sys.fulltext_document_types

-- load new IFilters
sp_fulltext_service 'load_os_resources', 1


